/*
 * search.java
 *
 * Created on 25 February 2003, 02:25
 */


/**
 *
 * @author  kjdon@cs.waikato.ac.nz
 * @author  davidb@cs.waikato.ac.nz
 * @version 
 */

import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.search.Searcher;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.Hits;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.TermQuery;
import org.apache.lucene.index.Term;

public class GS2LuceneQuery  {

    public static void main (String args[]) {
	
	if (args.length == 0) {
	    System.out.println("Usage: GS2LuceneQuery <index directory>");
	    return;
	}
        try {
	    Searcher searcher = new IndexSearcher(args[0]);
	    Analyzer analyzer = new StandardAnalyzer();

	    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	    while (true) {
		String line = in.readLine();
		
		if (line == null) {
		    break;
		}

		if (line.length() == -1)
		    break;
		

		// Term term = new Term("TX",line);
		// Query query = new TermQuery(term);

		System.err.println("**** query = " + line);

		Query query = QueryParser.parse(line, "TX", analyzer);
		
		Hits hits = searcher.search(query);
		System.out.println("<ResultSet>");
		System.out.println("  <QueryString>" + query.toString("TX")+"</QueryString>");
		System.out.println("  <MatchingDocsInfo num=\""+hits.length()+"\"/>");
				
		for (int i=0; i< hits.length(); i++) {
		    Document doc = hits.doc(i);
		    String node_id= doc.get("nodeID");
		    System.out.println("  <Match id=\""+node_id+"\"/>");
		}
		System.out.println("</ResultSet>");
		
	    }
	    
	    searcher.close();
	}
	catch (Exception e) {
	    System.out.println(" caught a " + e.getClass() +
			       "\n with message: " + e.getMessage());
        }
    }
}
